<?php

namespace Teknisa\DF\Modules\Entrada\Controllers;

use Zeedhi\Framework\DTO;

use Teknisa\DF\Modules\Entrada\Services\ProdutosXmlService;

class ProdutosXml extends \Teknisa\DF\Controllers\TeknisaCrud {

    protected $dataSourceName = 'produtos_xml';

    protected $parameterBagColumns = array(
        'NRACESSONFE',
        'CDFORNECED',
        'CDFILIAL'
    );

    public function __construct($crudService, $parameterBag, ProdutosXmlService $produtosXmlService) {
        parent::__construct($crudService, $parameterBag);
        $this->produtosXmlService = $produtosXmlService;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filters = $request->getFilterCriteria()->getConditions();
        $fornecedor = '';
        
        foreach($filters as $filter) {
            if($filter["columnName"] == 'CDFORNECED') $fornecedor = $filter["value"];
        }
        
        try {
          
            $utilizaRelacionamentoFilial = $this->produtosXmlService->utilizaRelacionamentoPorFilial($fornecedor);
        }
        catch(\Exception $e) {
            $utilizaRelacionamentoFilial = false;
        }
        
        if($utilizaRelacionamentoFilial) {
            $this->dataSourceName = 'produtos_xml_filial';
        }
        
        parent::find($request, $response);
    }

}